/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014-2016 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet_udp_task.h 167 2016-03-08 11:37:45Z coas-nagasima $
 */

/*
 *		ECHONET Lite ^XN
 */

#ifndef TOPPERS_ECHONET_UDP_TASK_H
#define TOPPERS_ECHONET_UDP_TASK_H

#ifdef __cplusplus
extern "C" {
#endif

#include <kernel.h>
#include "echonet.h"
#include "echonet_fbs.h"

/*
 *  ECHONET Lite ēAhX
 */
#ifdef SIL_ENDIAN_LITTLE
#define ECHONET_MULTICAST_ADDR {0,23,0,224}
#else
#define ECHONET_MULTICAST_ADDR {224,0,23,0}
#endif

/*
 *  ECHONET Lite ^XN֘A̒萔̃ftHgl̒`
 */
#ifndef ECHONET_UDP_TASK_PRIORITY
#define ECHONET_UDP_TASK_PRIORITY	3		/* Dx */
#endif /* ECHONET_UDP_TASK_PRIORITY */

#ifndef ECHONET_UDP_TASK_STACK_SIZE
#define ECHONET_UDP_TASK_STACK_SIZE	1024	/* X^bN̈̃TCY */
#endif /* ECHONET_UDP_TASK_STACK_SIZE */

#ifndef NUM_ECHONET_UDP_MAILBOX
#define NUM_ECHONET_UDP_MAILBOX	10
#endif /* NUM_ECHONET_UDP_MAILBOX */

/*
 *  ECHONET Lite ^XN̖{
 */
void echonet_udp_task(intptr_t exinf);

/*
 *  [gECHONETm[h̓KmF
 */
bool_t is_match(const EOBJCB *eobjcb, T_EDATA *edata, const void *_ipaddr, uint16_t portno);

/* IPAhX𕶎ɕϊ */
char *ipaddr2str(char *buf, int bubsz, uint8_t *ipaddr);

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_ECHONET_UDP_TASK_H */
